#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jan 20 05:00:19 2021

@author: wor

 databases in play:
    - deathsDB = deathsDB[1:] # drop the column headings
    - dates =  datePad + columnLabels[4:]
    - countriesList             = [] # collates all multiple-province country provinces into a single country entry
    - provinceDeathsDict        = {} # holds all country, province and summed-province data
    - populationDataList        = [] # demographic data

    - inJustDeathDB             = [] # countries/provinces that are only in deaths_global.csv
    - inJustpopulationDataList  = [] # countries/provinces that are only in countryPopulationData.csv
    - inBothDB = []
    - demographicDict           = {} # an amalgulm of the two .csv files data

   - covidInstanceDict      #  a list of instantiated CountryNames should that be a Dict then?

"""
import numpy as np
import config                                                                   # our global variables initialization module

if config.reportProgress:                                                       # True or False
    from datetime import datetime
    productionTime = datetime.now()
    print ("=== Begin covid19plotting.py:\t", productionTime)

from covid19class import CountryDeaths                                          # the Class definition need anything else?
from colorTables import *                                        # used to differentiate different max. daily death numbers for a province

# ===================  INSTANTIATION OF PROVINCES (GLOBAL) ====================
# Instantiate all non-zero cases Provinces, make a list of the zero case Provinces

"""
def instantiateProvinceDeathsDict():
    for province in config.provinceDeathsDict.keys():                               # this Dict contains just the province+country+deathDatadata 
        instance = CountryDeaths(province)
        if instance.cumulativeDeaths[-1] > 0:                                       # there are  deaths
#            config.covidInstanceDict2[province] = instance # do it last
            instance.SMAshortPeriod = 10
            instance.SMAlongPeriod  = 30
    #        print (instance.deathIncrements)
    #        x = instance.SMA2(instance.deathIncrements,instance.SMAshortPeriod)
    #        print (x)
            instance.SMAshortData = instance.SMA2(instance.deathIncrements,instance.SMAshortPeriod) # generate the SMA short period dataset
    #        y = instance.SMA2(instance.deathIncrements,instance.SMAshortPeriod)
    #        print (y)
    
            instance.SMAlongData = instance.SMA2(instance.deathIncrements,instance.SMAshortPeriod)
            config.covidInstanceDict2[province] = instance
    #        print (instance.SMAshortData)
    #        print (instance.SMAlongData)
        else:                                                                       # there are NO deaths in this province
            config.deathFreeProvincesList += [province]    
    
    #    config.provinceDeathsDict[province][0]     
    #    instanceString = "covidInstanceDict['"+province+"'] = CountryDeaths('"+province+"')"
    #    exec(instanceString)                  # create the instance
    
instantiateProvinceDeathsDict()
"""
# The following is an extraction of instantiation stuff from the the plotting file
def createInstanceDict2():
    for countryName in config.provinceDeathsDict.keys():        
        config.covidInstanceDict2[countryName] = CountryDeaths (countryName)                 # instantiate!
        config.covidInstanceDict2[countryName].plotColor = selectColor (config.covidInstanceDict2[countryName].max)   # select a color based in the map in plorColor
#    ================= < Anomolies > ==========================================
    if countryName in config.outlierProvinceList:                                     # defined in covid19class.py
        getMaxs = config.covidInstanceDict2[countryName].maxVals
        print ("The Max Values and their indices:", getMaxs)
        oldY = getMaxs[-1][1]
        newY = adjustY(countryName)
#        y= 19 # old Y - 1000
        x = getMaxs[-1][0]                                                     # the index of the max value
        config.covidInstanceDict2[countryName].deathIncrements[x] = newY              # the DB max value to be adjusted
        plt.annotate ('Anomoly adjustment\n was:'+str(oldY)+", now:"+str(newY), xy = (x-1,newY+2), xytext=(x-20,newY+20),   
            arrowprops=dict(facecolor='black', shrink=0.5))                    # point to the value of the adjuatment in the chart

createInstanceDict2 ()
 
instantiatedCountryStats = []                                                   # local to this file/operation only: move to end of instantiate.py module
def appendData2AllInstances():                                                  # appends data to covidInstanceDict2[dountries]
    for country in config.covidInstanceDict2.keys():                                   #create a list of list
        instantiatedCountryStats.append([
        config.covidInstanceDict2[country].countryName, 
        config.covidInstanceDict2[country].provinceName, 
        config.covidInstanceDict2[country].countryCode, 
        config.covidInstanceDict2[country].latitude, 
        config.covidInstanceDict2[country].longitude, 
        config.covidInstanceDict2[country].area, 
        config.covidInstanceDict2[country].population, 
        config.covidInstanceDict2[country].populationDensity, 
        config.covidInstanceDict2[country].max, 
        config.covidInstanceDict2[country].mean, 
        config.covidInstanceDict2[country].median,  
        config.covidInstanceDict2[country].sortedIndices[-2], 
        config.covidInstanceDict2[country].deathIncrements[config.covidInstanceDict2[country].sortedIndices[-2]], 
        config.covidInstanceDict2[country].sortedIndices[-1], 
        config.covidInstanceDict2[country].deathIncrements[config.covidInstanceDict2[country].sortedIndices[-1]]
        ])

appendData2AllInstances()


fname3 =            "instantiatedCountryStats.csv"
columnLabels =      ['Country','Province','Code','Latitude','Longitude','Area',
                     'Population','PopDensity','MaxNr','Mean','Median','AllButIndx',
                     'AllButVal', 'indxOfBiggest', 'BiggestVal']
#columnLabels = ''.join (columnLabels)
import csv
with open(config.dataDirectory + fname3, '+w', newline='') as myfile:
        writer = csv.writer(myfile, delimiter=',')
        writer.writerow(columnLabels)
        writer.writerows(instantiatedCountryStats)
myfile.close()

#    ================= </ Anomolies > =========================================

# from the bottom of the plotting file (outside the plotting functions):
#    Amalgamate info in the virus data bases with the demographic/population databases: cut to another data module
""" to be moved - not yet!
instantiatedCountryStats = [] 
for country in covidInstanceDict.keys():     #create a list of lists
    instantiatedCountryStats.append([
    covidInstanceDict[country].countryName, 
    covidInstanceDict[country].latitude, 
    covidInstanceDict[country].longitude, 
    covidInstanceDict[country].area, 
    covidInstanceDict[country].population, 
    covidInstanceDict[country].max, 
    covidInstanceDict[country].mean, 
    covidInstanceDict[country].median,  
    covidInstanceDict[country].sortedIndices[-2], 
    covidInstanceDict[country].deathIncrements[covidInstanceDict[country].sortedIndices[-2]], 
    covidInstanceDict[country].sortedIndices[-1], 
    covidInstanceDict[country].deathIncrements[covidInstanceDict[country].sortedIndices[-1]]
    ])

directory =         "/Users/davidworrall/Documents/RESEARCH/COVID-19/dataSets/"
directory =         "/volumes/DRWORANGE32/COVID-19/dataSets/"
imageDirectory =    "/volumes/DRWORANGE32/COVID-19/graphImages/deaths_global/"
fname3 =            "instantiatedCountryStats.csv" # "us-counties20200516.csv"
columnLabels =      ['Country','Latitude','Longitude','Area','Population','MaxNr','Mean','Median','AllButIndx',
                     'AllButVal', 'indxOfBiggest', 'BiggestVal']
#columnLabels = ''.join (columnLabels)
import csv
with open(dataDirectory + fname3, '+w', newline='') as myfile:
        writer = csv.writer(myfile, delimiter=',')
        writer.writerow(columnLabels)
        writer.writerows(instantiatedCountryStats)
myfile.close()

for kee in sorted(config.covidInstanceDict2.keys()):
    print (kee)
    barChartCountry(kee, kee, nrFigureCols = 1, directToFile=True)

""" # end of to to be moved - not yet
""" OLD :  perhaps superceded by the above .....
2020 11 12 added:
 Instantiate here using listOfCountryNames, covidInstanceDict


for province in provinceDeathsDict.keys():
    instance = CountryDeaths(province)
    if instance.cumulativeDeaths[-1] > 0:                                       # there are deaths
        config.covidInstanceDict2[province] = instance
        instance.SMAshortPeriod = 4
        instance.SMAlongPeriod = 14

        print ("======== Calculating the short and long SMAs ==========")
        print ("\n==== len("+province+"].deathIncrements): ", 
                                          len(instance.deathIncrements))
        shortArray = instance.SMA2(instance.deathIncrements, instance.SMAshortPeriod)  # generate the SMA short period dataset
        list2prepend = [0]* (len (instance.deathIncrements) - len (shortArray))        # an SMA produces an array shorter shorter than the original dataset 
        instance.SMAshortArray = np.insert(shortArray, list2prepend, 0)                # 0 arg means insert at the beginning
        print ("len(instance.SMAshortArray)", len (instance.SMAshortArray))            

        longArray = instance.SMA2(instance.deathIncrements, instance.SMAlongPeriod)    # generate the SMA short period dataset
        list2prepend = [0]* (len (instance.deathIncrements) - len (longArray))         # an SMA produces an array shorter shorter than the original dataset 
        instance.SMAlongArray = np.insert(longArray, list2prepend, 0)                 # 0 arg means insert at the beginning
        print ("len(instance.SMAlongArray)", len (instance.SMAlongArray))            

    else:                                                                       # there are NO deaths in this province
        deathFreeProvinces += [province]
"""
"""
# ============ PRINT PROVINCE DATA WITH MAX VALS & MAX VAL INDICES ===========
# print ("All Provinces\n=============\n", config.covidInstanceDict2.keys())
for kee in config.covidInstanceDict2.keys():
#    print (kee, end='\t')
    if kee in outlierProvinceList:
        maxVals = config.covidInstanceDict2[kee].sortedIndices[-3:]
        for indx in range(len(maxVals)):
            maxVals [indx] = (maxVals [indx],config.covidInstanceDict2[kee].deathIncrements[maxVals [indx]] )
print ()
#        print (maxVals)   #indices of the 3 largest daily death values # fix the values
#        print (config.covidInstanceDict2[kee].deathIncrements[])
#    else:
#        print ()

print ("Death-Free Provinces\n====================\n", deathFreeProvinces)

"""
# old - perhaps outdated comparison of rel between country data in demographic DB and covid databases
# to be cleaned !!!!!!!

"""  moved to covid19regionInstantiations.py --- test 4 removing
# check which countries in the populationDataList are or are not in the config.provinceDeathsDict.keys())
deathProvinceNames = sorted (config.provinceDeathsDict.keys())
inBothDB = []
inJustDeathDB = []
inJustpopulationDataList = []
for provinceNr in range (2, len (populationDataList)):
#    print (populationDataList[provinceNr][countryNameCol])
    if populationDataList[provinceNr][countryNameCol] in deathProvinceNames:
        inBothDB += [populationDataList[provinceNr][countryNameCol]]
    else:
        inJustDeathDB += [populationDataList[provinceNr][countryNameCol]]

# Now make a demographicDB data for those in inBothDB
for entry in populationDataList:
    if entry[countryNameCol] in inBothDB:
         config.demographicDict[entry[countryNameCol]] = entry                         # take it all easy - could from last index (censusDateCol)                         
                                                                                # was entry[:5] # regionName,countryName,countrySymbol,area,pop
#for region in config.demographicDict.keys():
#    print (config.demographicDict[region][:20])
"""

"""
Code for amalgamating data sources - used and then commented out.
provinceDensityDict = {}                              # a dict to hold all country, province and summed-province population data
for province in populationDataList:                   # Collates all provinces into a single dictionary entry
    if provinceDensityDict[0] == "":
        config.provinceDeathsDict [province[1]]  = province  # there is no province, the dict key is country
    else:
        config.provinceDeathsDict [province[0]]  = province  # there is more than one province so use the dict key as the province

def printAllProvinces():
    kees = sorted (config.provinceDeathsDict.keys())         # alpha sort for pretty print
    for keeNr in range (len (kees)):
        print (kees[keeNr], end="\t\t")
#        if keeNr % 3 == 0: print()

"""
"""
allSoFar=NorthWesternEurope +NorthEasternEurope +CentralEasternEurope +SouthWesternEurope
allSoFar2 =SouthEasternEurope +SouthAsia +NorthernAfrica +CentralAfrica +SouthernAfrica
allSoFar3 = Asia +SouthAsia +SouthEastAsia + MiddleEast
allSoFar += allSoFar2 +allSoFar3
allSoFar.sort()
print (len (allSoFar))
# identity check
#for province in config.provinceDeathsDict.keys():
#    if province not in allSoFar :
#        print (province)

#directory="/volumes/DRWORANGE32/COVID-19/dataSets/"
#aussie = CountryDeaths('Australia')#
#graphCountries (Australasia , 'Aussie')
#graphCountries(NorthWesternEurope, 'North-Western Europe')
notYetClassified = []

#  ============== Get Extract Regional Data ===================================
fname= "WorldRegionsUpdated.csv"

with open(directory+fname, newline='') as csvfile:
    ipdata = csv.reader(csvfile, delimiter=',', quotechar='"')
    for row in ipdata:
#        print (row[0])
        if row [0] in notYetClassified:
            print (row[:2])  # get the region

# "us-counties20200516.csv"


from datetime import datetime

for datey in range (dateBeginCol, len(deathsDB[colLabelRow])):
    deathsDB[colLabelRow][datey] = datetime.strptime(deathsDB[colLabelRow][datey], "%m/%d/%y").date()
#    print (deathsDB[colLabelRow][datey])

for datey in range (dateBeginCol, len(deathsDB[colLabelRow])-7, 4):
    print (deathsDB[colLabelRow][datey+7]- deathsDB[colLabelRow][datey])
    print (deathsDB[colLabelRow][datey])


dateDict={}


countyList = []

dateList = []
for place in deathsDB:
    if place[0] not in dateList:
        dateList += [place[0]]
dateList = dateList[1:]                                     # drop the column title
#print (dateList)
#print ("==========dates\n", dateList)
"""



"""
The 2020 geographic population data is from the INTERNET USAGE STATISTICS website which also has land-area:
https://www.internetworldstats.com/stats.htm
https://www.internetworldstats.com/list3.htm
World regions and old stats on reported cases (not deaths) in April 2020:\
        Africa
        Asia
        Central America
        Eastern Europe
        European Union
        Middle East
        North America
        Oceania
        South America
        The Caribbean

        AFRICA
        Eastern Africa
        Burundi - 405 cases-Aug 9/20, (5 cases April 20/20)
        Comoros - 399 cases-Aug 9/20, (no data April 20/20)
        Djibouti - 5,338 cases-Aug 9/20, (846 cases-Apr20/20)
        Eritrea - 285 cases-Aug 9/20, (39 cases-Apr20/20)
        Ethiopia - 22,253 cases-Aug 9/20, (108 cases-Apr20/20)
        Kenya - 25,837 cases-Aug 9/20, (270 cases-Apr20/20)
        Madagascar - 13,086 cases-Aug 9/20, (121 cases-Apr20/20)
        Malawi - 4,624 cases-Aug 9/20, (17 cases-Apr20/20)
        Mauritius - 344 cases-Aug 9/20, (328 cases-Apr20/20)
        Mayotte - 3,068 cases-Aug 9/20, (271 cases-Apr20/20)
        Mozambique - 2,241 cases-Aug 9/20, (39 cases-Apr20/20)
        Reunion - 681 cases-Aug 9/20, (408 cases-Apr20/20)
        Rwanda - 2,134 cases-Aug 9/20, (147 cases-Apr20/20)
        Seychelles - 126 cases-Aug 9/20, (11 cases-Apr20/20)
        Somalia - 3,227 cases-Aug 9/20, (164 cases-Apr20/20)
        Tanzania - 509 cases-Aug 9/20, (170 cases-Apr20/20)
        Uganda - 1,267 cases-Aug 9/20, (55 cases-Apr20/20)
        Zambia - 8,085 cases-Aug 9/20, (61 cases-Apr20/20)
        Zimbabwe - 4,575 cases-Aug 9/20, (25 cases-Apr20/20)

        Middle Africa
        Angola - 1,572 cases-Aug 9/20, (24 cases-Apr20/20)
        Cameroon - 18,042 cases-Aug 9/20, (1,017 cases-Apr20/20)
        CAR - 4,641 cases-Aug 9/20, (12 cases-Apr20/20)
        Chad - 942 cases-Aug 9/20, (33 cases-Apr20/20)
        Congo (Brazza) - 3,664 cases-Aug 9/20, (143 cases-Apr20/20)
        Congo, D. R. - 9,454 cases-Aug 9/20, (327 cases-Apr20/20)
        Equatorial Guinea - 4,821 cases-Aug 9/20, (79 cases-Apr20/20)
        Gabon - 7,923 cases-Aug 9/20, (109 cases-Apr20/20)
        Sao Tome and Princ - 878 cases-Aug 9/20, (4 cases-Apr20/20)

        Northern Africa
        Algeria - 34,693 cases-Aug 9/20, (2,629 cases-Apr20/20)
        Egypt - 95,314 cases-Aug 9/20, (3,144 cases-Apr20/20)
        Libya - 5,232 cases-Aug 9/20, (51 cases-Apr20/20)
        Morroco - 32,007 cases-Aug 9/20, (2,855 cases-Apr20/20)
        South Sudan - 2,463 cases-Aug 9/20, (4 cases-Apr20/20)
        Sudan - 11,894 cases-Aug 9/20, (92 cases-Apr20/20)
        Tunisia - 1,678 cases-Aug 9/20, (879 cases-Apr20/20)
        Western Sahara - 10 cases-Aug 9/20, (6 cases-Apr20/20)

        Southern Africa
        Botswana - 804 cases-Aug 9/20, (20 cases-Apr20/20)
        Eswatini - 3,128 cases-Aug 9/20, (22 cases-Apr20/20)
        Lesotho - 742 cases-Aug 9/20, (no data-Apr20/20)
        Namibia - 2,802 cases-Aug 9/20, (16 cases-Apr20/20)
        South Africa - 553,188 cases-Aug 9/20, (3,158 cases-Apr20/20)

        Western Africa
        Benin - 1,936 cases-Aug 9/20, (35 cases-Apr20/20)
        Burkina Faso - 1,175 cases-Aug 9/20, (576 cases-Apr20/20)
        Cape Verde - 2,835 cases-Aug 9/20, (61 cases-Apr20/20)
        Cote d'Ivoire - 16,620 cases-Aug 9/20, (847 cases-Apr20/20)
        Gambia - 1,090 cases-Aug 9/20, (10 cases-Apr20/20)
        Ghana - 41,003 cases-Aug 9/20, (1,042 cases-Apr20/20)
        Guinea - 7,875 cases-Aug 9/20, (579 cases-Apr20/20)
        Guinea-Bissau - 2,052 cases-Aug 9/20, (50 cases-Apr20/20)
        Liberia - 1,234 cases-Aug 9/20, (91 cases-Apr20/20)
        Mali - 2,565 cases-Aug 9/20, (224 cases-Apr20/20)
        Mauritania - 6,510 cases-Aug 9/20, (7 cases-Apr20/20)
        Niger - 1,157 cases-Aug 9/20, (648 cases-Apr20/20)
        Nigeria - 46,140 cases-Aug 9/20, (627 cases-Apr20/20)
        Saint Helena - no cases-Aug 9/20, (no cases-Apr20/20)
        Senegal - 11,175 cases-Aug 9/20, (367 cases-Apr20/20)
        Sierra Leone - 1,895 cases-Aug 9/20, (35 cases-Apr20/20)
        Togo - 1,046 cases-Aug 9/20, (84 cases-Apr20/20)

        THE AMERICAS
        North America, Latin America and the Caribbean

        The Caribbean
        Anguilla - 3 cases-Aug 9/20, (3 cases-Apr10/20)
        Antigua and Barbuda - 92 cases-Aug 9/20, (21 cases-Apr10/20)
        Aruba - 86 cases-Aug 9/20, (86 cases-Apr10/20)
        Bahamas - 878 cases-Aug 9/20, (42 cases-Apr10/20)
        Barbados - 138 cases-Aug 9/20, (67 cases-Apr10/20)
        British Virgin Islands - 9 cases-Aug 9/20, (3 cases-Apr10/20)
        Caribbean Netherlands - 13 cases-Aug 9/20, (2 cases-Apr10/20)
        Cayman Islands - 203 cases-Aug 9/20, (45 cases-Apr10/20)
        Cuba - 2,888 cases-Aug 9/20, (564 cases-Apr10/20)
        Curaçao - 31 cases-Aug 9/20, (14 cases-Apr10/20)
        Dominica - 18 cases-Aug 9/20, (16 cases-Apr10/20)
        Dominican Rep 78,778 cases-Aug 9/20, (2,620 cases-Apr10/20)
        Grenada - 24 cases-Aug 9/20, (14 cases-Apr10/20)
        Guadeloupe - 290 cases-Aug 9/20, (143 cases-Apr10/20)
        Haiti - 7,599 cases-Aug 9/20, (31 cases-Apr10/20)
        Jamaica - 1,003 cases-Aug 9/20, (63 cases-Apr10/20)
        Martinique - 336 cases-Aug 9/20, (155 cases-Apr10/20)
        Monserrat - 9 cases-Aug 9/20, (9 cases-Apr10/20)
        Puerto Rico - 22,121 cases-Aug 9/20, (1,068 cases-Apr17/20)
        Saint-Barthélemy - 9 cases-Aug 9/20, (6 cases-Apr10/20)
        St. Kitts and Nevis - 12 cases-Aug 9/20, (12 cases-Apr10/20)
        Saint Lucia - 25 cases-Aug 9/20, (15 cases-Apr10/20)
        Saint Martin - 78 cases-Aug 9/20, (32 cases-Apr10/20)
        Saint Vincent and the Grenadines - 57 cases-Aug 9/20, (12 cases-Apr10/20)
        Sint Maarten - 177 cases-Aug 9/20, (50 cases-Apr10/20)
        Trinidad and Tobago - 275 cases-Aug 9/20, (114 cases-Apr20/20)
        Turks and Caicos Islands - 170 cases-Aug 9/20, (11 cases-Apr20/20)
        Virgin Islands (US) - 528 cases-Aug 9/20, (53 cases-Apr20/20)

        Central America
        Belize - 146 cases-Aug 9/20, (18 cases-Apr18/20)
        Costa Rica - 22,802 cases-Aug 9/20, (655 cases-Apr18/20)
        El Salvador - 20,423 cases-Aug 9/20, (190 cases-Apr18/20)
        Guatemala - 56,189 cases-Aug 9/20, (235 cases-Apr18/20)
        Honduras - 46,973 cases-Aug 9/20, (457 cases-Apr18/20)
        Mexico - 475,902 cases-Aug 9/20, (3,441 cases-Apr10/20)
        Nicaragua - 3,902 cases-Aug 9/20, (7 cases-Apr10/20)
        Panama - 73,651 cases-Aug 9/20, (2,974 cases-Apr10/20)

        South America
        Argentina - 241,811 cases-Aug 9/20, (2,571 cases-Apr16/20)
        Bolivia - 89,055 cases-Aug 9/20, (441 cases-Apr16/20)
        Brazil - 3,013,369 cases-Aug 9/20, (28,912 cases-Apr16/20)
        Chile - 371,023 cases-Aug 9/20, (8,273 cases-Apr16/20)
        Colombia - 376,870 cases-Aug 9/20, (3,105 cases-Apr16/20)
        Ecuador - 93,572 cases-Aug 9/20, (8,225 cases-Apr16/20)
        Falkland Islands - 13 cases-Aug 9/20, (11 cases-Apr16/20)
        French Guiana - 8,267 cases-Aug 9/20, (86 cases-Apr16/20)
        Guyana - 554 cases-Aug 9/20, (55 cases-Apr16/20)
        Paraguay - 6,705 cases-Aug 9/20, (174 cases-Apr16/20)
        Peru - 471,012 cases-Aug 9/20, (12,491 cases-Apr16/20)
        Suriname - 2,306 cases-Aug 9/20, (10 cases-Apr16/20)
        Uruguay - 1,335 cases-Aug 9/20, (493 cases-Apr16/20)
        Venezuela - 24,961 cases-Aug 9/20, (197 cases-Apr16/20)

        Northern America
        Bermuda - 157 cases-Aug 9/20, (81 cases-Apr16/20)
        Canada - 119,221 cases-Aug 9/20, (29,929 cases-Apr16/20)
        Greenland - 14 cases-Aug 9/20, (11 cases-Apr16/20)
        Saint Pierre & Miquelon - 4 case-Aug 9/20, (1 case-Apr16/20)
        United States - 5,150,757 cases-Aug 9/20, (678,210 cases-Apr17/20)

         ASIA
        Afganistan - 37,054 cases-Aug 9/20, (993 cases-Apr19/20)
        Armenia - 40,410 cases-Aug 9/20, (1,291 cases-Apr19/20)
        Azerbaijan - 33,568 cases-Aug 9/20, (1,373 cases-Apr19/20)
        Bangladesh - 257,600 cases-Aug 9/20, (2,456 cases-Apr19/20)
        Bhutan - 108 cases-Aug 9/20, (5 cases-Apr19/20)
        Brunei Darussalam - 142 cases-Aug 9/20, (136 cases-Apr14/20)
        Cambodia - 251 cases-Aug 9/20, (122 cases-Apr14/20)
        China - 84,619-Aug 9/20, (82,249-Apr14/20)
        Georgia - 1,225 cases-Aug 9/20, (296 cases-Apr14/20)
        Hong Kong - 4,080 cases-Aug 9/20, (1,013 cases-Apr14/20)
        India - 2,158,408 cases-Aug 9/20, (10,541 cases-Apr14/20)
        Indonesia - 125,396 cases-Aug 9/20, (6,575 cases-Apr19/20)
        Japan - 45,439 cases-Aug 9/20, (7,645 cases-Apr14/20)
        Kazakhstan - 98,701 cases-Aug 9/20, (1,202 cases-Apr14/20)
        Korea, North - no data
        Korea, South - 14,598 cases-Aug 9/20, (10,564 cases-Apr14/20)
        Kyrgyzstan - 39,919 cases-Aug 9/20, (430 cases-Apr14/20)
        Laos - 20 cases-Aug 9/20, (19 cases-Apr14/20)
        Macao - 46 cases-Aug 9/20, (45 cases-Apr14/20)
        Malaysia - 9,083 cases-Aug 9/20, (4,987 cases-Apr14/20)
        Maldives - 4,898 cases-Aug 9/20, (20 cases-Apr14/20)
        Mongolia - 293 cases-Aug 9/20, (30 cases-Apr14/20)
        Myanmar - 359 cases-Aug 9/20, (63 cases-Apr14/20)
        Nepal - 22,972 cases-Aug 9/20, (16 cases-Apr14/20)
        Pakistan - 284,121 cases-Aug 9/20, (5,837 cases-Apr14/20)
        Phillipines - 129,913 cases-Aug 9/20, (6,259 cases-Apr19/20)
        Singapore - 55,104 cases-Aug 9/20, (6,588 cases-Apr19/20)
        Sri Lanka - 2,841 cases-Aug 9/20, (219 cases-Apr14/20)
        Taiwan - 480 cases-Aug 9/20, (420 cases-Apr19/20)
        Tajikistan - 7,827 cases-Aug 9/20, (no data-Apr19/20)
        Thailand - 3,351 cases-Aug 9/20, (2,613 cases-Apr14/20)
        Timor Leste (West) - 25 cases-Aug 9/20, (6 cases-Apr14/20)
        Turkmenistan - no data-Aug 9/20,
        Uzbekistan - 30,197 cases-Aug 9/20, (1,113 cases-Apr14/20)
        Vietnam - 841 cases-Aug 9/20, (266 cases-Apr14/20)

        EUROPE
        Albania - 6,275 cases-Aug 9/20, (562 cases-Apr19/20)
        Andorra - 963 cases-Aug 9/20, (704 cases-Apr19/20)
        Belarus - 68,850 cases-Aug 9/20, (4,779 cases-Apr19/20)
        Bosnia-H - 13,687 cases-Aug 9/20, (1,285 cases-Apr19/20)
        Croatia - 5,604 cases-Aug 9/20, (1,534 cases-Apr12/20)
        Faroe Islands - 303 cases-Aug 9/20, (184 cases-Apr12/20)
        Gibraltar - 197 cases-Aug 9/20, (129 cases-Apr12/20)
        Guerney and Alderney - 597 cases-Aug 9/20, (407 cases-Apr12/20)
        Iceland - 1,955 cases-Aug 9/20, (1,689 cases-Apr12/20)
        Jersey - 347 cases-Aug 9/20, (81 cases-Apr12/20)
        Kosovo - no Data, see Serbia
        Liechtenstein - 79 cases-Aug 9/20, (79 cases-Apr12/20)
        Man, Island of - 336 cases-Aug 9/20, (226 cases-Apr12/20)
        Moldova - 27,443 cases-Aug 9/20, (1,560 cases-Apr12/20)
        Monaco - 131 cases-Aug 9/20, (92 cases-Apr12/20)
        Montenegro - 3,588 cases-Aug 9/20, (263 cases-Apr12/20)
        North Macedonia - 11,754 cases-Aug 9/20, (760 cases-Apr12/20)
        Norway - 9,599 cases-Aug 9/20, (6,409 cases-Apr12/20)
        Russia - 887,536 cases-Aug 9/20, (13,584 cases-Apr12/20)
        San Marino - 699 cases-Aug 9/20, (356 cases-Apr12/20)
        Serbia - 27,863 cases-Aug 9/20, (3,380 cases-Apr12/20)
        Svalbard and Jan Mayen Islands - no Data
        Switzerland - 36,603 cases-Aug 9/20, (25,107 cases-Apr12/20)
        Turkey - 239,622 cases-Aug 9/20, (56,956 cases-Apr12/20)
        Ukraine - 80,949 cases-Aug 9/20, (2,511 cases-Apr12/20)
        UK - 309,763 cases-Aug 9/20, (103,093 cases-Apr17/20)
        Vatican City - 12 cases-Aug 9/20, (8 cases-Apr12/20)

        EUROPEAN UNION
        Austria - 22,033 cases-Aug 9/20, (14,476 cases-Apr17/20)
        Belgium - 73,401 cases-Aug 9/20, (34,809 cases-Apr17/20)
        Bulgaria - 13,343 cases-Aug 9/20, (825 cases-Apr17/20)
        Cyprus - 1,233 cases-Aug 9/20, (735 cases-Apr17/20)
        Czechia - 18,235 cases-Aug 9/20, (6,433 cases-Apr17/20)
        Denmark - 14,442 cases-Aug 9/20, (6,879 cases-Apr17/20)
        Estonia - 2,152 cases-Aug 9/20, (1,434 cases-Apr17/20)
        Finland - 7,584 cases-Aug 9/20, (3,369 cases-Apr17/20)
        France - 197,921 cases-Aug 9/20, (165,027 cases-Apr17/20)
        Germany - 216,896 cases-Aug 9/20, (137,698 cases-Apr17/20)
        Greece - 5,421 cases-Aug 9/20, (2,207 cases-Apr17/20)
        Hungary - 4,696 cases-Aug 9/20, (1,763 cases-Apr17/20)
        Ireland - 26,644 cases-Aug 9/20, (13,271 cases-Apr17/20)
        Italy - 250,103 cases-Aug 9/20, (168,941 cases-Apr17/20)
        Latvia - 1,290 cases-Aug 9/20, (675 cases-Apr17/20)
        Lithuania - 2,252 cases-Aug 9/20, (1,128 cases-Apr17/20)
        Luxembourg - 7,169 cases-Aug 9/20, (3,444 cases-Apr17/20)
        Malta - 1,089 cases-Aug 9/20, (412 cases-Apr17/20)
        Netherlands - 57,987 cases-Aug 9/20, (29,214 cases-Apr17/20)
        Poland - 51,791 cases-Aug 9/20, (7,918 cases-Apr17/20)
        Portugal - 52,537 cases-Aug 9/20, (18,841 cases-Apr17/20)
        Romania - 61,768 cases-Aug 9/20, (7,707 cases-Apr17/20)
        Slovakia - 2,596 cases-Aug 9/20, (977 cases-Apr17/20)
        Slovenia - 2,247 cases-Aug 9/20, (1,268 cases-Apr17/20)
        Spain - 361,442 cases-Aug 9/20, (184,948 cases-Apr17/20)
        Sweden - 82,323 cases-Aug 9/20, (12,540 cases-Apr17/20)

        MIDDLE EAST
        Bahrain - 43,629 cases-Aug 9/20, (1,773 cases-Apr19/20)
        Iran - 326,712 cases-Aug 9/20, (82,211 cases-Apr19/20)
        Iraq - 147,389 cases-Aug 9/20, (1,513 cases-Apr19/20)
        Israel - 82,515 cases-Aug 9/20, (13,362 cases-Apr19/20)
        Jordan - 1,246 cases-Aug 9/20, (413 cases-Apr19/20)
        Kuwait - 71,199 cases-Aug 9/20, (1,915 cases-Apr19/20)
        Lebanon - 6,223 cases-Aug 9/20, (673 cases-Apr19/20)
        Oman - 81,580 cases-Aug 9/20, (1,266 cases-Apr19/20)
        Palestine - 14,205 cases-Aug 9/20, (431 cases-Apr19/20)
        Qatar - 112,947 cases-Aug 9/20, (5,448 cases-Apr19/20)
        Saudi Arabia - 287,262 cases-Aug 9/20, (8,274 cases-Apr19/20)
        Syria - 1,125 cases-Aug 9/20, (38 cases-Apr19/20)
        UAE - 62,525 cases-Aug 9/20, (6,781 cases-Apr19/20)
        Yemen - 1,797 case-Aug 9/20, (1 case-Apr19/20)

        OCEANIA
        Australia - 20,698 cases-Aug 9/20, (6,497 cases-Apr17/20)
        Fiji - 27 cases-Aug 9/20, (17 cases-Apr17/20)
        French Polynesia - 69 cases-Aug 9/20, (55 cases-Apr17/20)
        Guam (USA) - 411 cases-Aug 9/20, (135 cases-Apr17/20)
        Kiribati - no data
        Marshall Islands - no data
        Micronesia - no data
        New Caledonia - 23 cases-Aug 9/20, (18 cases-Apr17/20)
        New Zealand - 1,569 cases-Aug 9/20, (1,409 cases-Apr17/20)
        Northern Mariana Islands (USA) - 48 cases-Aug 9/20, (13 cases-Apr17/20)
        Samoa - no data
        Samoa, American - no data
        Solomon, Islands - no data
        Tonga - no data
        Vanuatu - no data
"""

